/* userlist.... */
/* gs>>  you'll probably have to change this a little...  */
/*       at least the directories will be wrong... (look down a page) */

/* And don't laugh at my coding...  :) */

/* This code started out as my mailing list program...  and this is it's
   fourth generation, i think. [Mailing list, Keyserve, nodelist, userlist] */
/* Thats why there are a few unused variables around... you can ignore um...
   or delete um if you feel like it... */

#include  <stdio.h>
#include  <stdlib.h>
#include  <string.h>
#include  <dos.h>
#include  <conio.h>
#include  <time.h>
#include  "pragmas.h"

typedef char label[31];

void startup(void);
unsigned long readMessage(void);
void WriteMessage(void);
int  GetStr(FILE *fil, char *str, int mlen);
void PutStr(FILE *fl, char *str);
int  sort(const void *this, const void *that);
void stripansi(char *str);

FILE    *mailin, *mailout;

/* Change these... */
char    inputmail[129]  = "c:\\cit\\messages\\msg.dat";
char	outputmail[129] = "users.lst";

time_t	starttime, endtime;

char    messagetext[8193];
char 	author[31];
char	node[31];
char	sig[81];
long	nmessages = 0;
long	messagek = 0;
int	numuser = 0;

struct user {
	char username[31];
	long messages;
	long msgk;
            };

struct user *usertable;

/* Main */
void main()
{
int i;
unsigned long good = 1;

     starttime = time(NULL);

     startup();

     while(good)
     {
     good = readMessage();
     }

     qsort(usertable, numuser, sizeof(struct user), sort);

	fprintf(mailout, "     Username                          msgs    msgb    AVb/msg    %%msgs   %%msgb\n");
	fprintf(mailout, "     \n");

    for(i=0; i<numuser; i++)
    if(((float)usertable[i].msgk/(float)messagek*100 >= (float)0.12) && stricmp(usertable[i].username, "Skaro") != NULL)
	fprintf(mailout, "%3d. %-30.30s  %5ld  %6lu  %7.2f  %5.2f%%  %4.2f%%\n",
		   i+1,
		   usertable[i].username,
		   usertable[i].messages,
		   usertable[i].msgk,
		   ((float)usertable[i].msgk/(float)usertable[i].messages),
		   ((float)usertable[i].messages/(float)nmessages*100),
		   ((float)usertable[i].msgk/(float)messagek*100)
                   );

   fprintf(mailout, "\nList generated from %ld messages totaling %ld bytes.\n", nmessages, messagek);

   fclose(mailin);
   fclose(mailout);

   endtime = time(NULL);
   printf("\nElapsed time: %f", difftime(endtime, starttime));

   exit(0);
}

/*
 * Read a message...
 */
unsigned long readMessage(void)
{
    char c;

    author[0] = 0;
    sig[0]    = 0;

    /* find start of message */
    do
    {
	c = (unsigned char)fgetc(mailin);
    } while (c != -1 && !feof(mailin));

    if (feof(mailin))
	return 0;

    do
    {
	c = (unsigned char)fgetc(mailin);

	switch (c)
	{
	case 'A':     messagek += GetStr(mailin, author,    30);  break;
	case '.':     messagek += GetStr(mailin, sig,	    80);  break;
	case 'M':						  break;
	case 'O':     messagek += GetStr(mailin, node,	    30);  break;

	default:
	    /* this isn't right...fix it sometime. */
	    messagek += GetStr(mailin, messagetext, 8192); /* discard unknown field */
	    messagetext[0]    = 0;
	    break;
	}

    } while (c != 'M' && !feof(mailin));

    if (feof(mailin))
	return 0;

    GetStr(mailin, messagetext, 8192);

/* Only messages in netrooms get Node Signatures...  this is how we detect */
/* local netmessages...  So you need to have at least one #sig setup in cit. */

    if(node[0] || sig[0])
      {
      messagek += strlen(messagetext);
      nmessages++;
      WriteMessage();
      }

    return 1;
}

/*
 * putmessage.
 */
void WriteMessage(void)
{
int usernum, lp;

   stripansi(author);

   if(!stricmp(author, "Skaro"))
	{
	author[0]      = 0;
	messagetext[0] = 0;
	return;
	}

   for (lp=0, usernum=-1; lp<numuser; lp++)
       if (stricmp(author, usertable[lp].username)==0)
	   usernum=lp;

   if (usernum==-1)
   {
       numuser++;
       usernum=numuser-1;

       usertable = (void *)realloc((void *)usertable, numuser * sizeof(struct user));

       strcpy(usertable[usernum].username, author);
       usertable[usernum].messages = 1;
       usertable[usernum].msgk = strlen(messagetext);

//       printf("new user: [%25s]\n", author);
   printf("!");
   }
   else
   {
   	usertable[usernum].messages++;
	usertable[usernum].msgk += strlen(messagetext);
   }

	author[0] = 0;
	messagetext[0] = 0;
}

/**********************************/
/* sort thingy.                   */
/**********************************/
int sort(const void *this1, const void *that1)
{
  const struct user *this = this1;
  const struct user *that = that1;
  long valret=0;

  if(this->msgk > that->msgk)
	valret = 0;
  else
	valret = 1;

  return(valret > 0L ? 1 : -1);
}

/* -------------------------------------------------------------------- */
/*  GetStr()        gets a null-terminated string from a file           */
/* -------------------------------------------------------------------- */
int GetStr(FILE *fil, char *str, int mlen)
{

    int   l = 0;
    unsigned char ch = 1;

    while(!feof(fil) && ch)
    {
	ch=(unsigned char)fgetc(fil);
	if ((ch != 0xFF && ch != '\r') && l < mlen)
	{
	    str[l]=ch;
	    l++;
	}
    }
    str[l]='\0';

    return(l);
}

/* -------------------------------------------------------------------- */
/*  PutStr()        puts a null-terminated string to a file             */
/* from dragcit also... */
/* -------------------------------------------------------------------- */
void PutStr(FILE *fl, char *str)
{
    fwrite(str, sizeof(char), (strlen(str) + 1), fl);
}

/* changes string being sent, does not return a pointer like deansi */
/* And this was taken from GremCit... */
void stripansi(char *str)
{
    int i=0;

    char *pc;
    pc = str;

    while (*pc)  
    {
        if (*pc == 1)   pc += 2;   /* Zap Ctrl-A plus following Char */
        else
        {
            str[i] = *pc;
            i++;
            pc++;
        }
    }
    str[i] = 0;
}    

/* -------------------------------------------------------------------- */
/*  startup...  opens all files.                                        */
/* -------------------------------------------------------------------- */
void startup(void)
{
   usertable = (void *)calloc(1, sizeof(struct user));

   if((mailin = fopen(inputmail, "rb")) == NULL)
     {
	 printf("\n\n Can not open output.net.\n");
         exit(1);
     }

   setvbuf(mailin, NULL, _IOFBF, 4096);

   if((mailout = fopen(outputmail, "wt")) == NULL)
     {
	 printf("\n\n Can not open mesg.tmp.\n");
	 exit(1);
     }

   fprintf(mailout, "53List of CitNet users.0\n"
		    "\n"
		    "This list is limited to those users who's messages make up more than .12%%\n"
		    "of total CitNet traffic.\n"
		    "\n"
		    "%%msgs is based on the number user messages / total citnet msgs.\n"
		    "%%msgb is based on the total bytes put out by the user / citnet bytes.\n"
		    "\n");
}
